apiVersion: unfurl/v1alpha1
kind: Ensemble
spec:
  shared:
    compute:
      dockerhost:
        type: unfurl.nodes.TraefikDockerComputeHost
      db-dockerhost:
        type: unfurl.nodes.DockerComputeHost
      redis-dockerhost:
        type: unfurl.nodes.DockerComputeHost
  deployment_blueprints:
    +include:
      file: deployment-blueprints.yaml
      repository:
        url: https://gitlab.com/onecommons/unfurl-types

  service_template:
    description:
      A safe home for all your data. Access & share your files, calendars, contacts, mail & more from any device, on your terms.

    metadata:
      template_name: Nestedcloud
      template_author:
      template_version: 0.1
      livePreview: #url to a live preview
      image: # url to image
      sourceCodeUrl: # url to the source code repository
      deployments: 0
      webUrl: # url to the source project
      primaryDeploymentBlueprint: gcp

    repositories:
      types:
        url: https://gitlab.com/onecommons/unfurl-types

    imports:
      - file: service-template.yaml
        repository: types

    node_types:
      Nestedcloud:
        derived_from: unfurl.nodes.App
        properties:
          url:
            type: string
            default:
              eval: .targets::nested::url

        requirements:
          - nested:
              node: unfurl.nodes.WebApp
              relationship: unfurl.relationships.Configures

    topology_template:
      substitution_mappings:
        node: the_app

      outputs:
        # NB: the app's url attribute will not be computed unless this is declared
        url:
          value:
            eval: ::the_app::url

      node_templates:
        the_app:
          type: Nestedcloud
